#*************************************************************
# Progamm:			fluisa_wlgl_inst_1d
# Sinn des Programms: 		Löser der instationären Wärmeleitungsgleichung 1d
# Sinn der Einheit  :		Aufstellung der Koeffizientenmatrix
# Name der Datei    :		rand_bed.py
# Versionsnummer:		1
# Wird aufgerufen von:		fluisa_wlgl_inst_1d_haupt.py
# Ruft auf:			-
# Nummer im Programmpaket:	4
# von:				7
# Autor: 			Armin Ulrich
# Erster Lauf: 			12.04.2018
# Letzte Änderung: 		17.12.2022
#*************************************************************

#*************************************************************
# Import der Klasse os zum Bearbeiten von Dateien
#*************************************************************
import os
import numpy as np

#*************************************************************
# Klassendefinition Koeffizientenmatrix
#*************************************************************
class Rand_bed:
  #Konstruktormethode
  def __init__(self):		
    print("Randbedingungsobjekt erzeugt")


  #Destruktormethode
  def __del__(self):	
    print("Randbedingungsobjekt entfernt")   
    
#*************************************************************
# Funktion zum Einlesen der Randbedingungen
#*************************************************************
  def rand_bed_input(self,rand_datei):
    self.rückgabeliste = list(range(2))
    self.rückgabeliste[0] = True                                 # Einlesen der Randbedingungen korrekt            True/False
    self.rückgabeliste[1] = "Randdatei wurde korrekt gelesen"    # Fehlermeldung für Einlesen der Randbedingungen  Text
    print("Einlesen der Randbedingungen")    
    print("Name der Randbedingungs_datei:",rand_datei)
    if os.path.exists(rand_datei):
      print("Datei ist vorhanden")
      self.rand_art = list(range(2))
      self.rand_wert = np.zeros(2)
      fobj_in = open(rand_datei,"r") 
      zeile=fobj_in.readline()
      self.puffer = zeile[:-1]
      zeile=fobj_in.readline()
      self.puffer = zeile[:-1]
      dummy = self.puffer.split("\t")
      self.rand_art[0]=dummy[0]
      self.rand_wert[0]=float(dummy[1])
      zeile=fobj_in.readline()
      self.puffer = zeile[:-1]
      zeile=fobj_in.readline()
      self.puffer = zeile[:-1]
      dummy   = self.puffer.split("\t")
      self.rand_art[1]=dummy[0]
      self.rand_wert[1]=float(dummy[1])
      fobj_in.close()

    else:
      self.rückgabeliste[0] = False                                   # Randbedingungen falsch            True/False
      self.rückgabeliste[1] = "Randdatei nicht vorhanden"             # Randdatei nicht vorhanden
      print("Datei ist NICHT vorhanden")
    return self.rückgabeliste[0]
